<template>
  <div v-if="!announcement.IsHidden" class="py-2 bg-background1 h-[32px] pl-4">
    <div class="container flex items-center h-full mx-auto">
      <utils-announcement :announcement="announcement.Text" />
    </div>
  </div>
  <div
  class="overflow-hidden overflow-y-auto bg-background2 relative h-[calc(100vh-140px)]"
  >
  <banner-mobile
    :theme-properties="themeProperties"
    :actived="'HomeInitial'"
    class="mobileBannerCarouselBfm1"
    @hasBanner="(val) => (hasBanner = val)"
  />
    <sport-m-popular-match v-if="isRecommendMatchEnabled" class="px-4" />
    <div class="home-entry-section" v-if="menuTabHeadersModified.length">
      <new-black-theme-horizontal-home-button
        v-for="menu in menuTabHeadersModified"
        :key="menu.TabType"
        :link="menu.TabURL"
        :bg-image="`/new_black_theme/home_bg/${checkImg(menu)}_home_bg.png`"
        :logo-image="`/new_black_theme/home_logo/img_mainentry_${menu.TabType.replace(
          ' ',
          ''
        ).toLowerCase()}_h72.png`"
        :name="menu.TabType"
        class="home-entry-item"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed, ref } from "vue";
import _ from "lodash";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";
import { useHeaderComponent } from "@/composables/useTheme";
import { TabInfo } from "@/models/IGetPlayableGamesResponse";
import commonHelper from "@/utils/commonHelper";
import { gameStore } from "~~/store/game";
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";

export default defineComponent({
  name: "Home",
  setup() {
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const sportBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_1"
        )
    );
    const virtualSportBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_2"
        )
    );
    const casinoBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_3"
        )
    );
    const gamesBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_4"
        )
    );
    const cockFightBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_5"
        )
    );
    const promotionBanner = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "lobby_banner_6"
        )
    );
    const isRecommendMatchEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "sportsbook_recommend_matches"
        ).IsHidden
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "announcement"
        )
    );

    const games = computed(() => gameStore.state.games);
    const isSportEnabled = computed(() => {
      const isHidden = sportBanner.value.IsHidden;
      const sportCount = _.filter(
        games.value,
        (item) => item.Category === 1 && item.ForMobile === true
      ).length;
      return !isHidden && sportCount > 0;
    });
    const isVirtualSportEnabled = computed(() => {
      const isHidden = virtualSportBanner.value.IsHidden;
      const virtualSportCount = _.filter(
        games.value,
        (item) => item.Category === 4 && item.ForMobile === true
      ).length;
      return !isHidden && virtualSportCount > 0;
    });
    const isCasinoEnabled = computed(() => {
      const isHidden = casinoBanner.value.IsHidden;
      const casinoCount = _.filter(
        games.value,
        (item) => item.Category === 2 && item.ForMobile === true
      ).length;
      return !isHidden && casinoCount > 0;
    });
    const isGamesEnabled = computed(() => {
      const isHidden = gamesBanner.value.IsHidden;
      return !isHidden;
    });
    const isCockfightEnabled = computed(() => {
      const isHidden = cockFightBanner.value.IsHidden;
      const cockFightCount = _.filter(
        games.value,
        (item) => item.GameProviderId === 46
      ).length;
      return !isHidden && cockFightCount > 0;
    });
    const isPromotionEnabled = computed(() => {
      const isHidden = promotionBanner.value.IsHidden;
      return !isHidden;
    });

    const hasPoker = computed(
      () =>
        gameStore.state.games.findIndex((item) => item.TabType === "Poker") >= 0
    );
    const hasLottery = computed(
      () =>
        gameStore.state.games.findIndex((item) => item.TabType === "Lottery") >=
        0
    );
    const checkImg = (menu: TabInfo) => {
      if (menu.TabType.toLowerCase().includes("sports")) {
        return "sports";
      }
      if (menu.TabType.toLowerCase().includes("casino")) {
        return "casino";
      }
      if (menu.TabType.toLowerCase().includes("cock")) {
        return "cock";
      }
      return menu.TabType.toLowerCase();
    };
    const { menuTabHeaders, isAllowPromotionTab } = useHeaderComponent();
    const menuTabHeadersModified = computed(() => {
      if (menuTabHeaders.value && isAllowPromotionTab.value) {
        return [
          ...menuTabHeaders.value,
          {
            TabType: "Promotion",
            Order: 8,
            isFilter: false,
            TabLanguage: "promotion",
            TabURL: "/promotion",
          },
        ];
      }
      return menuTabHeaders.value || [];
    });
    const hasBanner = ref(false);
    const { themeColor } = themePropertyHelper;

    return {
      announcement,
      isSportEnabled,
      isVirtualSportEnabled,
      isCasinoEnabled,
      isGamesEnabled,
      isCockfightEnabled,
      isPromotionEnabled,
      sportBanner,
      virtualSportBanner,
      casinoBanner,
      gamesBanner,
      cockFightBanner,
      promotionBanner,
      isRecommendMatchEnabled,
      hasPoker,
      hasLottery,
      menuTabHeaders,
      checkImg,
      themeProperties,
      hasBanner,
      themeColor,
      menuTabHeadersModified,
    };
  },
});
</script>
<style scoped>
.el-carousel__container {
  height: 125px;
}
</style>
<style lang="scss">
.home-entry-section {
  display: grid;
  grid-template-columns: repeat(2, minmax(0, 1fr));
  flex-wrap: wrap;
  gap: 0.5rem 0.5rem;
  justify-content: space-between;
  padding: 0.5rem;
  width: 100%;
}
.home-entry-item {
  height: 20vw;
  margin-bottom: 0.5rem;
}
.mobileBannerCarouselBfm1 {
  .el-carousel__indicators {
    .el-carousel__indicator {
      &.is-active .el-carousel__button {
        background: var(--primary);
      }
      .el-carousel__button {
        width: 5px;
        height: 5px;
        border-radius: 2px;
        background: rgba(255, 255, 255, 0.5);
      }
    }
  }
  .el-carousel__container {
    .el-carousel__arrow {
      display: none;
    }
  }
}
</style>
<style lang="scss">
[theme-color="global_light_01"] {
  .card-title {
    color: var(--text3);
  }
}
</style>